#include "CUnit.h"
#include "beispiele.h"
#include <stdio.h>

int main(int argc, char** args){
  const char *FAC1 = "fac1";
  const char *FAC2 = "fac2";
  const char *FAC3 = "fac3";
  const char *ERATOSTHENES1 = "eratosthenes 1";
  const char *ERATOSTHENES2 = "eratosthenes 2";
  const char *MYSTERY1 = "mystery1";
  const char *MYSTERY2 = "mystery2";
  const char *MYSTERY3 = "mystery3";
  const char *MYSTERY4 = "mystery4";
  const char *MYSTERY5 = "mystery5";
  const char *MYSTERY6 = "mystery6";
  const char *GGT1 = "ggt1";
  const char *GGT2 = "ggt2";
  const char *GGT3 = "ggt3";
  const char *GGT4 = "ggt4";
  const char *GGT5 = "ggt5";
  const char *MATRIXMULT = "matrixMult";

  testDeclare(FAC1);
  testDeclare(FAC2);
  testDeclare(FAC3);
  testDeclare(ERATOSTHENES1);
  testDeclare(ERATOSTHENES2);
  testDeclare(MYSTERY1);
  testDeclare(MYSTERY2);
  testDeclare(MYSTERY3);
  testDeclare(MYSTERY4);
  testDeclare(MYSTERY5);
  testDeclare(MYSTERY6);
  testDeclare(GGT1);
  testDeclare(GGT2);
  testDeclare(GGT3);
  testDeclare(GGT4);
  testDeclare(GGT5);
  testDeclare(MATRIXMULT);

  testStart(FAC1);
  assertIntEq("Fakultät von 5",120,factorial(5));

  testStart(FAC2);
  assertIntEq("Fakultät von 0",1,factorial(0));

  testStart(FAC3);
  assertIntEq("Fakultät von 1",1,factorial(1));

  testStart(ERATOSTHENES1);
  bool ar [10] = {false,false,false,false,false,false,false,false,false,false}; 
  eratosthenes(ar,10); 
  assertTrue("array[0] muss true sein, denn 2 ist Primzahl",ar[0]);
  assertTrue("array[1] muss true sein, denn 3 ist Primzahl",ar[1]);
  assertTrue("array[2] muss false sein, denn 4 ist keine Primzahl",!ar[2]);
  assertTrue("array[3] muss true sein, denn 5 ist Primzahl",ar[3]);
  assertTrue("array[4] muss false sein, denn 6 ist keine Primzahl",!ar[4]);
  assertTrue("array[5] muss true sein, denn 7 ist Primzahl",ar[5]);
  assertTrue("array[6] muss false sein, denn 8 ist keine Primzahl",!ar[6]);
  assertTrue("array[7] muss false sein, denn 9 ist keine Primzahl",!ar[7]);
  assertTrue("array[8] muss false sein, denn 10 ist keine Primzahl",!ar[8]);
  assertTrue("array[9] muss true sein, denn 11 ist Primzahl",ar[9]);

  testStart(ERATOSTHENES2);
  bool ar2 [100];
  eratosthenes(ar2,100);
  assertTrue("array[95] muss true sein, denn 97 ist eine Primzahl",ar2[95]);
  assertTrue("array[96] muss false sein, denn 98 ist keine Primzahl",!ar2[96]);
  assertTrue("array[97] muss false sein, denn 99 ist keine Primzahl",!ar2[97]);
  assertTrue("array[98] muss false sein, denn 100 ist keine Primzahl",!ar2[98]);
  assertTrue("array[99] muss true sein, denn 101 ist eine Primzahl",ar2[99]);
  
  testStart(MYSTERY1);
  assertIntEq("mystery(10,3)",30,mystery(10,3));

  testStart(MYSTERY2);
  assertIntEq("mystery(10,-3)",-30,mystery(10,-3));

  testStart(MYSTERY3);
  assertIntEq("mystery(0,-3)",-0,mystery(0,-3));

  testStart(MYSTERY4);
  assertIntEq("mystery(10,0)",-0,mystery(10,0));

  testStart(MYSTERY5);
  assertIntEq("mystery(-10,3)",-30,mystery(-10,3));

  testStart(MYSTERY6);
  assertIntEq("mystery(-10,-3)",30,mystery(-10,-3));

  testStart(GGT1);
  assertIntEq("ggt(10,4)",2,ggt(10,4));

  testStart(GGT2);
  assertIntEq("ggt(4,10)",2,ggt(4,10));

  testStart(GGT3);
  assertIntEq("ggt(0,10)",10,ggt(0,10));

  testStart(GGT4);
  assertIntEq("ggt(51,99)",3,ggt(51,99));

  testStart(GGT5);
  assertIntEq("ggt(1,1)",1,ggt(1,1));
  
  testStart(MATRIXMULT);
  double a0 [] = {1,2,3};
  double a1 [] = {4,1,0};
  double a2 [] = {5,2,-3};
  double* a []= {a0,a1,a2};

  double b0 [] = {2,1,-3};
  double b1 [] = {-1,0,4};
  double b2 [] = {1,2,-4};
  double* b [] = {b0,b1,b2};

  double c0 [] = {0,0,0};
  double c1 [] = {0,0,0};
  double c2 [] = {0,0,0};
  double* c [] = {c0,c1,c2};
  matrixMult(a,b,c,3);

  assertIntEq("Position c[0][0] falsch nach Matrix-Multiplikation",3,c[0][0]);
  assertIntEq("Position c[0][1] falsch nach Matrix-Multiplikation",7,c[0][1]);
  assertIntEq("Position c[0][2] falsch nach Matrix-Multiplikation",-7,c[0][2]);
  assertIntEq("Position c[1][0] falsch nach Matrix-Multiplikation",7,c[1][0]);
  assertIntEq("Position c[1][1] falsch nach Matrix-Multiplikation",4,c[1][1]);
  assertIntEq("Position c[1][2] falsch nach Matrix-Multiplikation",-8,c[1][2]);
  assertIntEq("Position c[2][0] falsch nach Matrix-Multiplikation",5,c[2][0]);
  assertIntEq("Position c[2][1] falsch nach Matrix-Multiplikation",-1,c[2][1]);
  assertIntEq("Position c[2][2] falsch nach Matrix-Multiplikation",5,c[2][2]);
  
  shutdown();
  return 0;
}
