import unittest

from Baum  import *

def baumeq(me, other):
  if me.isEmpty and other.isEmpty: return True
  if not me.isEmpty and not other.isEmpty:
    if me.element!=other.element: return False;
    if len(list(me.childNodes)) != len(list(other.childNodes)): return False;
    else:  
      for p in list(zip(me.childNodes,other.childNodes)):
        if not (baumeq(p[0],p[1])): return False;
      return True
  else:
    return False

 
class TreeTest(unittest.TestCase):
  b0=Baum()
  b1=Baum()
  b2=Baum()
  b3=Baum()
  b4=Baum()

  def setUp(self):
     self.b0 = Baum()
     self.b1 = Baum("a")
     self.b2 = Baum( "a", [Baum( "b1"),Baum( "b10"),Baum( "b11"),Baum( "b12"),Baum( "b2"),Baum("b3"),Baum("b4"),Baum("b5"),Baum("b6"),Baum("b7"),Baum("b8"),Baum("b9"),Baum("c")])
     self.b3 = Baum( "a", [self.b2,Baum( "b"),Baum( "c"),Baum( "c")]) 
     self.b4 = Baum( "z",[self.b1,self.b2,self.b3,self.b3])

  def testGroesse1(self):
    self.assertEqual(0,self.b0.groesse())
  def testGroesse2(self):
    self.assertEqual(1,self.b1.groesse())
  def testGroesse3(self):
    self.assertEqual(14,self.b2.groesse())
  def testGroesse4(self):
    self.assertEqual(18,self.b3.groesse())
  def testGroesse5(self):
    self.assertEqual(52,self.b4.groesse())
     
  def testEnthaelt1(self):
    self.assertFalse(self.b0.enthaelt(5))
  def testEnthaelt2(self):
    self.assertFalse(self.b1.enthaelt(5))
  def testEnthaelt3(self):
    self.assertTrue(self.b1.enthaelt("a"))
  def testEnthaelt4(self):
    self.assertTrue(self.b4.enthaelt("a"))


  def testMaxDepth1(self):
    self.assertEqual(0, self.b0.maxDepth())
  def testMaxDepth2(self):
    self.assertEqual(1, self.b1.maxDepth())
  def testMaxDepth3(self):
    self.assertEqual(2, self.b2.maxDepth())
  def testMaxDepth4(self):
    self.assertEqual(3, self.b3.maxDepth())
  def testMaxDepth5(self):
    self.assertEqual(4, self.b4.maxDepth())

  def testMaxWidth1(self):
    self.assertEqual(0, self.b0.maxWidth())
  def testMaxWidth2(self):
    self.assertEqual(0, self.b1.maxWidth())
  def testMaxWidth3(self):
    self.assertEqual(13, self.b2.maxWidth())
  def testMaxWidth4(self):
    self.assertEqual(13, self.b3.maxWidth())
  def testMaxWidth5(self):
    self.assertEqual(13, self.b4.maxWidth())


  def testElemente1(self):
    self.assertEqual([], self.b0.elemente())
  def testElemente2(self):
    self.assertEqual(["a"],  self.b1.elemente())
  def testElemente3(self):
    self.assertEqual(['a','b1','b10','b11','b12','b2','b3','b4','b5','b6','b7','b8','b9','c'], self.b2.elemente())
  def testElemente4(self):
    self.assertEqual(['a','a','b1','b10','b11','b12','b2','b3','b4','b5','b6','b7','b8','b9','c','b','c','c'],  self.b3.elemente())
  def testElemente5(self):
    self.assertEqual(["z","a","a","b1",'b10','b11','b12','b2','b3','b4','b5','b6','b7','b8','b9', 'c',
   'a','a','b1','b10','b11','b12','b2','b3','b4','b5','b6','b7','b8','b9','c',
   'b',
   'c',
   'c',
   'a','a','b1','b10','b11','b12','b2','b3','b4','b5','b6','b7','b8','b9','c',
   'b',
   'c',
   'c'], self.b4.elemente())


  def testFringe1(self):
    self.assertEqual( [], self.b0.fringe())
  def testFringe2(self):
    self.assertEqual( ["a"], self.b1.fringe())
  def testFringe3(self):
    self.assertEqual( ['b1','b10','b11','b12','b2','b3','b4','b5','b6','b7','b8','b9','c'], self.b2.fringe())
  def testFringe4(self):
    self.assertEqual( ['b1','b10','b11','b12','b2','b3','b4','b5','b6','b7','b8','b9','c','b','c','c'], self.b3.fringe())
  def testFringe5(self):
    self.assertEqual( ['a','b1','b10','b11','b12','b2','b3','b4','b5','b6','b7','b8','b9','c','b1','b10','b11','b12','b2','b3','b4','b5','b6','b7','b8','b9','c','b','c','c','b1','b10','b11','b12','b2','b3','b4','b5','b6','b7','b8','b9','c','b','c','c'], self.b4.fringe())


  def testAbbilden0(self):
    self.assertTrue(baumeq(self.b0, self.b0.abbilden(lambda x:x.upper())))

  def testAbbilden1(self):
     e1 = Baum("A")
     e2 = Baum( "A", [Baum( "B1"),Baum( "B10"),Baum( "B11"),Baum( "B12"),Baum( "B2"),Baum("B3"),Baum("B4"),Baum("B5"),Baum("B6"),Baum("B7"),Baum("B8"),Baum("B9"),Baum("C")])
     e3 = Baum( "A", [e2,Baum( "B"),Baum( "C"),Baum( "C")]) 
     e4 = Baum( "Z",[e1,e2,e3,e3])

     self.assertTrue(baumeq(e1, self.b1.abbilden(lambda x:x.upper())))

  def testAbbilden2(self):
     e1 = Baum("A")
     e2 = Baum( "A", [Baum( "B1"),Baum( "B10"),Baum( "B11"),Baum( "B12"),Baum( "B2"),Baum("B3"),Baum("B4"),Baum("B5"),Baum("B6"),Baum("B7"),Baum("B8"),Baum("B9"),Baum("C")])
     e3 = Baum( "A", [e2,Baum( "B"),Baum( "C"),Baum( "C")]) 
     e4 = Baum( "Z",[e1,e2,e3,e3])
     self.assertTrue(baumeq(e2, self.b2.abbilden(lambda x:x.upper())))

  def testAbbilden3(self):
     e1 = Baum("A")
     e2 = Baum( "A", [Baum( "B1"),Baum( "B10"),Baum( "B11"),Baum( "B12"),Baum( "B2"),Baum("B3"),Baum("B4"),Baum("B5"),Baum("B6"),Baum("B7"),Baum("B8"),Baum("B9"),Baum("C")])
     e3 = Baum( "A", [e2,Baum( "B"),Baum( "C"),Baum( "C")]) 
     e4 = Baum( "Z",[e1,e2,e3,e3])
     self.assertTrue(baumeq(e3, self.b3.abbilden(lambda x:x.upper())))

  def testAbbilden4(self):
     e1 = Baum("A")
     e2 = Baum( "A", [Baum( "B1"),Baum( "B10"),Baum( "B11"),Baum( "B12"),Baum( "B2"),Baum("B3"),Baum("B4"),Baum("B5"),Baum("B6"),Baum("B7"),Baum("B8"),Baum("B9"),Baum("C")])
     e3 = Baum( "A", [e2,Baum( "B"),Baum( "C"),Baum( "C")]) 
     e4 = Baum( "Z",[e1,e2,e3,e3])
     self.assertTrue(baumeq(e4, self.b4.abbilden(lambda x:x.upper())))
  

  def testLognestPath1(self):
    self.assertEqual([], self.b0.longestPath())
  def testLognestPath2(self):
    self.assertEqual(["a"], self.b1.longestPath())
  def testLognestPath3(self):
    self.assertEqual(["a","b1"], self.b2.longestPath())
  def testLognestPath4(self):
    self.assertEqual(["a","a","b1"], self.b3.longestPath())
  def testLognestPath5(self):
    self.assertEqual(["z","a","a","b1"], self.b4.longestPath())

  def testFaltung1(self):
    self.assertEqual("", self.b0.faltung(lambda x,y: max(x,y),""))
  def testFaltung2(self):
    self.assertEqual("a",self.b1.faltung(lambda x,y: max(x,y),""))
  def testFaltung3(self):
    self.assertEqual("c",self.b2.faltung(lambda x,y: max(x,y),""))
  def testFaltung4(self):
    self.assertEqual("c",self.b3.faltung(lambda x,y: max(x,y),""))
  def testFaltung5(self):
    self.assertEqual("zaab1b10b11b12b2b3b4b5b6b7b8b9caab1b10b11b12b2b3b4b5b6b7b8b9cbccaab1b10b11b12b2b3b4b5b6b7b8b9cbcc", self.b4.faltung(lambda x,y: x+y,""))